#ifdef VC2005EE
#include "stdafx.h"
#endif
//ustawienie BCPP50_BB50
#ifdef BCPP50
#define BCPP50_BB50
#endif
#ifdef BB50
#define BCPP50_BB50
#endif
//

#ifdef BCPP50
//Borland C++ 5.0
#include <owl/decframe.h>

#include <owl/window.h>
#include <math.h>
#include <stdio.h>
#endif
#ifdef BB50
//Borland Builder 5.0
#include <windows.h>
#endif

#ifndef VC2005EE
#include "samples.h"
#endif

#include "funs.h"

//------------------------
#ifdef _MANAGED
#pragma managed(push, off)
#endif

#ifdef VC2005EE
#define user_mode extern "C" void __declspec( dllexport )

BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
	case DLL_PROCESS_DETACH:
		break;
	}
    return TRUE;
}
#endif
#ifdef _MANAGED
#pragma managed(pop)
#endif

#ifdef BCPP50
#define user_mode extern "C" void FAR _cdecl _export
#pragma argsused
BOOL WINAPI DllEntryPoint(
		  HINSTANCE hinstDll,
        DWORD fdwReason,
        LPVOID lpvReserved) {
   if (!::Module) {
		static TModule module(0, hinstDll);
		::Module = &module;
		};
#endif
#ifdef BB50
#define user_mode extern "C" void FAR _cdecl _export
BOOL WINAPI DllMain(
        HINSTANCE hinstDLL,
        DWORD fdwReason,
        LPVOID lpvReserved) {
#endif

#ifdef BCPP50
   switch(fdwReason)  {
        case DLL_PROCESS_ATTACH :
                // miejsce na inicjacje modulu
        case DLL_PROCESS_DETACH :
                //miejsce na zamykanie modulu
                // usuwanie tablic "miernikow" - ew. mozna pominac
                DeleteSamples();
                //MessageBox(GetActiveWindow(),"zamykanie","",0);
                break;
        }
   return(true);
};
#endif
#ifdef BB50
   switch(fdwReason)  {
        case DLL_PROCESS_ATTACH :
                // miejsce na inicjacje modulu
                break;
        case DLL_PROCESS_DETACH :
                //miejsce na zamykanie modulu
                // usuwanie tablic "miernikow" - ew. mozna pominac
// sprawdzic AG////////// DeleteSamples();
                break;
        }
   return(true);
};

HWND TCadWindowHandle;
user_mode SetTCadWindowHandle(HWND twh) {
   TCadWindowHandle = twh;
};
#endif

#ifdef QT
//same as VC2005EE
#define user_mode extern "C" void __declspec( dllexport )
#endif

double czas0 = 0, czas1 = 0, czas1_ = czas1;

user_mode SaveUserToys() {
	#ifdef BCPP50
	SaveSamples();
    #endif
   czas1_ = czas1;
};

user_mode RestoreUserToys() {
	#ifdef BCPP50
	RestoreSamples();
    #endif
   czas1 = czas1_;
};

#ifdef BCPP50
#define EV_MESSAGEFROMUSER 200

LRESULT SendMessageToTCad(WPARAM wParam,LPARAM lParam=0) {
	TWindow* UserWindow = new TWindow(0,Module);//alias dla user.dll
HWND TCad_HWnd = UserWindow->GetApplication()->GetMainWindow()->HWindow;
LRESULT res = SendMessage(TCad_HWnd,EV_MESSAGEFROMUSER,wParam,lParam);
   delete UserWindow;//mozna pominac
   return res;
};
#endif

#ifdef BB50
#define EV_MESSAGEFROMUSER 200
LRESULT SendMessageToTCad(WPARAM wParam,LPARAM lParam=0) {
LRESULT res = 0;
   if (TCadWindowHandle) res = SendMessage(TCadWindowHandle,EV_MESSAGEFROMUSER,wParam,lParam);
   return res;
};
#endif


#ifdef BCPP50
#pragma argsused
#endif
#ifdef BB50
#pragma argsused
#endif

user_mode user_1(
	double &y0,
	double x0, double x1, double x2, double x3, double time, double step,
	double &a1, double &a2, double &a3, double &a4, double &a5, double &a6,
	double &x) {
#ifdef BCPP50_BB50
char s[100];
HWND *lista, selected;
int i, liczba_okien;
//do przesylania tekstu
char *tekst;
unsigned long *paczka;
#endif

switch ((int)a1) {
        case 0: y0 = 12;
        return;
        case 1:
        //multiwibrator monostabilny
        multi_mono(y0, x0, time, a2, a3, a4, a5, x);
        return;
        case 2:
        //detektor maksimum
        max_detect(y0, x0, a2, a3, a4, a5, x);
        return;
        case 3:
      	//detektor minimum
        min_detect(y0, x0, a2, a3, a4, a5, x);return;
        case 4:
      	// Sterowanie silnikiem SRM a2/a3
      	sterowanie_SRM_N(y0, a2, a3, x0, x1, x2, step, x);
        return;
        #ifdef BCPP50_BB50
        case 5:
      	if ((time>a2) && !x) {
         	x = 1;
         	strcpy(s,"komunikat z user.dll\ngreetings!");
                SendMessageToTCad(0,(LPARAM)s);
         	};
         return;
        case 6:
      	if ((time>a2) && !x) {
         	x = 1;
         	SendMessageToTCad(1);
         	};
        	return;
        case 7:
      	if ((time>a2) && !x) {
         	x = 1;
         	SendMessageToTCad(2);
         	};
        	return;
        case 8:
        if (time<a2) return;
        if ((time<a3) && (x==1)) return;
        if ((time<a4) && (x==2)) return;
        if (x==3) return;
        MessageBeep(0);
        //podaj list okien wyswietlanych przebiegow:
        lista = (HWND*)SendMessageToTCad(3);
        if (!lista) {x = 0; return;};
        liczba_okien = (int)lista[0];
        wsprintf(s,"liczba okien przebiegw wynosi %d",liczba_okien);
        //MessageBox(GetActiveWindow(),s,"liczba okien",MB_OK);
        if (!liczba_okien) return;
        /**/
        selected = 0;
        for (i=0; i<liczba_okien; i++) {
           GetWindowText(lista[i+1],s, sizeof(s)-1);
           //MessageBox(GetActiveWindow(), s, "GetWindowText()", MB_OK);
           switch ((int)x) {
              case 0:
                if (strstr(s,"USER_1")) selected = lista[i+1];
                break;
              case 1:case 2:
                if (strstr(s,"tytu ustawiony z bloku user")) selected = lista[i+1];
                break;
              };
           };
        if (selected) {
           SetWindowText(selected, "tytu ustawiony z bloku user");
           //spakowanie informacji o tekscie i jego pooeniu
           //unsigned long paczka[tekst, x, y, okno]
           //char *tekst
           tekst = new char [100];
           paczka = new unsigned long [4];
           paczka[0] = (unsigned long) selected;
           paczka[1] = (unsigned long) tekst;
           switch ((int)x) {
              case 0:
              strcpy(tekst, "wywietlany tekst po \"a2\"");
              paczka[2] = 100;//x we wsprzdnych okna
              paczka[3] = 100;//y we wsprzdnych okna
              break;
              case 1:
              strcpy(tekst, "wywietlany tekst po \"a3\"");
              paczka[2] = 200;//x we wsprzdnych okna
              paczka[3] = 100;//y we wsprzdnych okna
              break;
              case 2:
              strcpy(tekst, "");
              };
           SendMessageToTCad(100, (unsigned long)paczka);
           delete paczka;
           delete tekst;
           };
        x++;
        /**/
        return;
        #endif
        case 32764:
      	//blok transmitancji (1+sT1)/(1+sT2) z ograniczeniami
        transmit_3(y0,x0,a2,a3,a4,a5,x,step);
        return;
        case 32765:
      	//blok probkujaco-pamietajacy, strobowany zboczem
        oblicz_upp(y0, x0, x1, a3, a2, x);
      	return;
        case 32766:
      	//blok obliczajacy czas pomiedzy impulsami (polowy okresu)
      	oblicz_interwal_sprytniej(y0, a2, x, a3, x0, time, a4);
      	return;
        case 32767:
      	//blok obliczajacy czas pomiedzy impulsami (pelnego okresu)
      	oblicz_interwal(y0, a2, x, a3, x0, time);
      	return;
        //case 1111: y0=80;return;
        default: y0 = 0; return;
        };
};

#ifdef BCPP50
#pragma argsused
#endif
#ifdef BB50
#pragma argsused
#endif

user_mode user_2(
	double &y0, double &y1,
	double x0, double x1, double x2, double x3,
	double time, double step,
	double &a1, double &a2, double &a3, double &a4, double &a5, double &a6,
	double &x) {
#ifdef BCPP50
int indeks;
#endif
unsigned long *info;// [liczgal, liczwez, ID, Iz, Un]
int i, lg, *ID;
double *Iz;
switch ((int)a1) {
        case 1:
      	// Sterowanie tranzystora dla falownika SRM
			SRM_inverter_switch(y0, y1, x, (int) x0, (int) a2,
   			x1, x2, x3, a4, a5);
        return;
        case 100:
        	//RegularModulator(x0, x1, step, a2, a4, a5, x, a3, a6, y0, y1);
        return;
        case 32764:
      	transmit_3(y0,x0,a2,a3,a4,a5,x,step);
      	y1 = x;
   		return;
        case 32767:
        #ifdef BCPP50
        //miernik tablicujacy dane wejsciowe
        //Przy inicjacji (czyli takze w modelu) a4 powinno byc ZERO.
        //Pozniej a4 zostanie ustawione na wartosc od jeden wzwyz
        //- na numer porzadkowy miernika liczac od JEDEN.
        indeks = (int)a4;
        DopiszProbkeDoMiernika(indeks,x0,time,a2,0,x3);
        a4 = indeks;

        y0 = GetParameter(indeks, ID_AV);
        y1 = GetParameter(indeks, ID_RMS);
        #else
        #ifndef QT
        MessageBeep(0);
        #endif
        y0 = 0;
        y1 = 0;
        #endif
        return;
        case 1000:
        mlevel_3_0(a2, x0, x1, a4, a5, y0, y1);
        break;
        case 200:
        #ifndef QT
        //mona zrobic lepiej: zawolac SendMessageToTCad(4) tylko raz i przechowac adresy
        // np. w zmiennych globalnych
        info = (unsigned long*)SendMessageToTCad(4);
        if (!info) return;
        switch ((int)a2) {
           case 0:
              lg = (int)info[0];//liczba galezi
              ID = (int*)info[2];//tablica identyfikatorow
              //szukam galezi "i" o ID[i]=200, czyli pierwszej galezi silnika ACAP
              i=0; while ((i<lg) && (ID[i]!=200)) i++;//
              if (i>=lg) {y0=-1; y1 = lg; return;};// fiasko
              y0 = i;
              Iz = (double*)info[3];
              y1 = Iz[i];
              break;
           }
           return;
         #endif
   	default:
      	y0 = 0;
        y1 = 0;
        return;
        };
};

#ifdef BCPP50
#pragma argsused
#endif
#ifdef BB50
#pragma argsused
#endif

user_mode user_3(
	double &y0, double &y1, double &y2,
	double x0, double x1, double x2, double x3,
	double time, double step,
	double &a1, double &a2, double &a3, double &a4, double &a5, double &a6,
	double &x) {
#ifdef BCPP50
int indeks;
#endif
switch ((int)a1) {
        case 0:
      	// Sterowanie silnikiem SRM 6/4
      	sterowanie_SRM(y0, y1, y2,	x0, x1, x2, step, a5, a6, x);
        return;
        case 1:
        	// zle - zmienna czas0 nie jest chroniona
         czas0 += step;
         y0 = czas0;
         // dobrze - zmienna czas1 jest chroniona przez czas1_
         czas1 += step;
         y1 = czas1;
         // dobrze - zmienna x jest chroniona przez TCad
         x += step;
         y2 = x;
         return;
        case 32767:
        #ifdef BCPP50
        //miernik tablicujacy dane wejsciowe
        //Przy inicjacji (czyli takze w modelu) a4 powinno byc ZERO.
        //Pozniej a4 zostanie ustawione na wartosc od jeden wzwyz
        //- na numer porzadkowy miernika liczac od JEDEN.
        indeks = (int)a4;
        DopiszProbkeDoMiernika(indeks,x0,time,a2,a3,x3);
        a4 = indeks;

        y0 = GetParameter(indeks, ID_AV);
        y1 = GetParameter(indeks, ID_RMS);
        y2 = GetParameter(indeks, ID_FAB);
        #else
        #ifndef QT
        MessageBeep(0);
        #endif
        y0 = 0;
        y1 = 0;
        #endif
      	return;
        default:
      	y0 = 0;
         y1 = 0;
         y2 = 0;
        return;
        };
};

//UZUPENIENIE OD WERSJI Z GRUDNIA '2004
#ifdef BCPP50
#pragma argsused
#endif
#ifdef BB50
#pragma argsused
#endif

user_mode user_MN(
/*
(****************************************************
Sugeruje sie, by parametr a[0] uzywa jako rodzaj (identyfikator) funkcji.
Bloki USER moga bezposrednio sterowac lacznikami.
W takim przypadku sterujacemu wyjsciu nalezy przypisa wartosc niska okreslona
przez a[1] badz wysoka - okreslona przez a[2]
Tablice "a", "s" i "y" mozna traktowa jako zmienne przez cala symulacje.
Tablica "s" moze zostac przepisana do warunkw poczatkowych przez
"Aktualizacj stanu ukladu""

dla bloku N wyjsciowego:
N = 20: n_x=20, n_a= 13, n_s= 8, n_y=20;
N = 10: n_x=10, n_a= 11, n_s=10, n_y=10;
N =  6: n_x=10, n_a= 13, n_s= 6, n_y= 6;
*/
 double* x, //	x[0]..x[n_x-1]
 double* a, //	a[0]..a[n_a-1]
 double* s, // s[0]..s[n_s-1]
 double time, double step,
 double* y  //	y[0]..y[n_y-1]
 ) {
 int i, mode = (int)a[0];
 //double YL = a[1];
 //double YH = a[2];

 switch (mode) {
 	case 1://przepisanie wej na wyjcia dla bloku 20/20
		for (i=0;i<19;i++) y[0] = x[i];
 		break;
   default:
   	//ustawienie na "1" wyj od 0 do 5
      for (i=0;i<5;i++) y[0] = 1;
   };
 return;
};

//KONIEC UZUPENIENIA OD WERSJI Z GRUDNIA '2004
